 /*  Accesspoint - station communication without router
 *  see: https://github.com/esp8266/Arduino/blob/master/doc/esp8266wifi/station-class.rst
 *  Works with: accesspoint_bare_01.ino
 */

#include <ESP8266WiFi.h>
#include <Wire.h>
#include <SPI.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>
//#include <DHT.h>
//#define DHTTYPE DHT11
//#define DHTPIN  2

byte ledPin = 2;
char ssid[] = "Wemos_AP";           // SSID of your AP
char pass[] = "Wemos_comm";         // password of your AP


String webString="";     // String to display
// Generally, you should use "unsigned long" for variables that hold time
unsigned long previousMillis = 0;        // will store last temp was read
const long interval = 5000;              // interval at which to read sensor

//DHT dht(DHTPIN, DHTTYPE, 11); // 11 works fine for ESP8266
Adafruit_BME280 bme; // I2C

#define SEALEVELPRESSURE_HPA (1013.25)

IPAddress server(192,168,4,15);     // IP address of the AP
WiFiClient client;

void setup() {
      unsigned status;
  Serial.begin(19200);
Wire.pins(0, 2);
Wire.begin(0, 2);

  status = bme.begin();
      if (!status) {
        Serial.println("Could not find a valid BME280 sensor, check wiring, address, sensor ID!");
        Serial.print("SensorID was: 0x"); Serial.println(bme.sensorID(),16);
        Serial.print("        ID of 0xFF probably means a bad address, a BMP 180 or BMP 085\n");
        Serial.print("   ID of 0x56-0x58 represents a BMP 280,\n");
        Serial.print("        ID of 0x60 represents a BME 280.\n");
        Serial.print("        ID of 0x61 represents a BME 680.\n");
        while (1);
    }
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, pass);           // connects to the WiFi AP
  Serial.println();
  Serial.println("Connection to the AP");
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(500);
  }

  Serial.println();
  Serial.println("Connected");
  Serial.println("station_bare_01.ino");
  Serial.print("LocalIP:"); Serial.println(WiFi.localIP());
  Serial.println("MAC:" + WiFi.macAddress());
  Serial.print("Gateway:"); Serial.println(WiFi.gatewayIP());
  Serial.print("AP MAC:"); Serial.println(WiFi.BSSIDstr());
  
  pinMode(ledPin, OUTPUT);
}


void gettemperature() {
volatile float humidity, temp_f, pressure, altitude;  // Values read from sensor

  // Wait at least 2 seconds seconds between measurements.
  // if the difference between the current time and last time you read
  // the sensor is bigger than the interval you set, read the sensor
  // Works better than delay for things happening elsewhere also
  unsigned long currentMillis = millis();
 
  if(currentMillis - previousMillis >= interval) {
    // save the last time you read the sensor 
    previousMillis = currentMillis;   

    // Reading temperature for humidity takes about 250 milliseconds!
    // Sensor readings may also be up to 2 seconds 'old' (it's a very slow sensor)
    humidity = bme.readHumidity();          // Read humidity (percent)
    temp_f = bme.readTemperature();     // Read temperature as Fahrenheit
    pressure = (bme.readPressure() / 100.0F);
    altitude = (bme.readAltitude(SEALEVELPRESSURE_HPA));
    
//      Serial.println(temp_f,0);
//      Serial.println(humidity,0);

    // Check if any reads failed and exit early (to try again).
    if (isnan(humidity) || isnan(temp_f)) {
      Serial.println("Failed to read from sensor!");
    }
      client.print('<'); 
      client.print("sensor 1,");
      client.print(temp_f,1);
      client.print(",");
      client.print(humidity,1);
//  Serial.println(client.print(","));
//  Serial.println(client.print(pressure,0));
//  Serial.println(client.print(","));
//  Serial.println(client.print(altitude,0));
      client.print('>');
      client.print('\r');
  }
}


void loop() {

 
  client.connect(server, 80);
  digitalWrite(ledPin, LOW);
  gettemperature(); 

  
  String answer = client.readStringUntil('\r');
  Serial.println("From the AP: " + answer);
  client.flush();
  digitalWrite(ledPin, HIGH);
  client.stop();
  delay(5000);
}
